package main

import (
	"flag"
	"net/http"
	"os"

	"github.com/prometheus/client_golang/prometheus/promhttp"

	"git.majava.org/software/tripla/tripla-fintraffic-rt/pkg/rail"
)

func main() {
	baseUrl := flag.String("base-url", "http://app-httpd/api", "")
	apiToken := flag.String("api-token", os.Getenv("TRIPLA_FINTRAFFICRT_API_TOKEN"), "")
	flag.Parse()

	p := rail.NewProcessor(*baseUrl, *apiToken)
	p.StartJourneyUpdater()

	http.Handle("/metrics", promhttp.Handler())
	err := http.ListenAndServe(":8000", nil)
	if err != nil {
		panic(err)
	}
}
