package common

import (
	"fmt"
)

// TODO: move to some shared Go package.

type Identifier interface {
	ToString() string
}

// NumericIdentifier is a Tripla identifier with a system ID and a number.
type NumericIdentifier struct {
	Identifier

	SystemId string `json:"system"`
	IdNumber int    `json:"idNumber"`
}

func (n NumericIdentifier) ToString() string {
	return fmt.Sprintf("%v:%v", n.SystemId, n.IdNumber)
}

// DatedNumericIdentifier is a NumericIdentifier that also includes a date specifier.
type DatedNumericIdentifier struct {
	NumericIdentifier

	Date string `json:"date"`
}

func (d DatedNumericIdentifier) ToString() string {
	return fmt.Sprintf("%v:%v:%v", d.SystemId, d.IdNumber, d.Date)
}

// TextIdentifier is a Tripla identifier with a system ID and a text code.
type TextIdentifier struct {
	Identifier

	SystemId string `json:"system"`
	IdText   string `json:"idText"`
}

func (t TextIdentifier) ToString() string {
	return fmt.Sprintf("%v:%v", t.SystemId, t.IdText)
}
