package rail

import (
	"git.majava.org/software/tripla/tripla-fintraffic-rt/pkg/common"
)

const DataSourceType = "fintraffic-rail"

type TrackedJourney struct {
	JourneyId      string                        `json:"journeyId"`
	SourceId       common.TextIdentifier         `json:"sourceId"`
	JourneyLocator common.DatedNumericIdentifier `json:"journeySourceLocator"`

	VersionNumber int
}

type MqttCompositionMessage struct {
	TrainNumber     int    `json:"trainNumber"`
	DepartureDate   string `json:"departureDate"`
	Version         int    `json:"version"`
	JourneySections any    `json:"journeySections"`
}

func (m MqttCompositionMessage) TrainId() common.DatedNumericIdentifier {
	return common.DatedNumericIdentifier{
		NumericIdentifier: common.NumericIdentifier{
			SystemId: "fintraffic",
			IdNumber: m.TrainNumber,
		},
		Date: m.DepartureDate,
	}
}
