package config

import (
	"os"

	"codeberg.org/emersion/go-scfg"
)

type SourceConfig struct {
	Name  string `scfg:",param"`
	Proxy string `scfg:"proxy"`
}

type Config struct {
	Sources []*SourceConfig `scfg:"source"`
}

func LoadConfig(file string) (*Config, error) {
	f, err := os.Open(file)
	if err != nil {
		return nil, err
	}
	defer f.Close()

	config := Config{}
	if err := scfg.NewDecoder(f).Decode(&config); err != nil {
		return nil, err
	}

	return &config, nil
}
