package main

import (
	"flag"
	"fmt"
	"io"
	"net/http"

	"google.golang.org/protobuf/proto"

	"git.majava.org/software/tripla/tripla-gtfs-rt/internal/gtfs/rt"
)

func main() {
	feedUrl := flag.String("feed-url", "", "")
	flag.Parse()

	response, err := http.Get(*feedUrl)
	if err != nil {
		panic(err)
	}
	defer response.Body.Close()

	body, err := io.ReadAll(response.Body)
	if err != nil {
		panic(err)
	}

	message := rt.FeedMessage{}
	err = proto.Unmarshal(body, &message)
	if err != nil {
		panic(err)
	}

	for _, entity := range message.GetEntity() {
		fmt.Printf("%v\n", entity)
	}
}
