package processor

import (
	"fmt"
)

const DataSourceType = "gtfs-rt"

// TextIdentifier is an Tripla identifier with a system ID and a text code.
// TODO: move to some shared Go package.
type TextIdentifier struct {
	SystemId string `json:"system"`
	IdText   string `json:"idText"`
}

func (t TextIdentifier) ToString() string {
	return fmt.Sprintf("%v:%v", t.SystemId, t.IdText)
}

type GtfsRtSource struct {
	Identifier TextIdentifier `json:"id"`
	GtfsRtUrl  string         `json:"gtfsRtUrl"`

	journeysToTrack map[string]TrackedJourney
}

type GtfsJourneyLocator struct {
	TripId string `json:"tripId"`
}

type TrackedJourney struct {
	JourneyId      string             `json:"journeyId"`
	SourceId       TextIdentifier     `json:"sourceId"`
	JourneyLocator GtfsJourneyLocator `json:"journeySourceLocator"`
}
