package processor

import (
	"encoding/json"
	"errors"
	"fmt"
	"io"
	"net/http"
)

func (p *Processor) GetAndParseJson(path string, target any) error {
	req, err := http.NewRequest("GET", fmt.Sprintf("%v%v", p.baseUrl, path), nil)
	if err != nil {
		return err
	}
	req.Header.Set("Authorization", fmt.Sprintf("Bearer %v", p.apiToken))

	response, err := p.httpClient.Do(req)
	if err != nil {
		return err
	}
	defer response.Body.Close()

	if response.StatusCode != http.StatusOK {
		return errors.New(fmt.Sprintf("Unexpected status %v %v", response.StatusCode, response.Status))
	}

	body, err := io.ReadAll(response.Body)
	if err != nil {
		return err
	}

	return json.Unmarshal(body, target)
}
